/*
 * ComboBoxSheetProperty.java
 *
 * Created on 16 febbraio 2005, 19.13
 */

package it.businesslogic.ireport.gui.sheet;

import it.businesslogic.ireport.ExpressionContext;
import javax.swing.*;

public class ExpressionSheetProperty extends SheetProperty {
    
    private ExpressionSheetPropertyComponent editor = null;
    private boolean plainTextEditor = false;   
 
    public ExpressionSheetProperty(String key, String name) {
        super( key, name, SheetProperty.STRING, "");
    }
    
    public JComponent getEditor()
    {
        if (editor != null) return editor;
        editor = new ExpressionSheetPropertyComponent();
        editor.addActionListener( this );
        return editor;
    }
    
    public Object getEditorValue(JComponent component)
    {
        return editor.getExpression();
    }
    
    public void setEditorValue(JComponent component, Object str)
    {
        try {
            getEditor(); // In this way we are sure that editor is not null.
            
            if (str != null)
            {
                editor.setExpression(""+str);
            }
            else
            {
                editor.setExpression("");
            }
        } catch (Exception ex) {}
    }
    
    public void setExpressionContext(ExpressionContext ex)
    {
        ((ExpressionSheetPropertyComponent)getEditor()).setExpressionContext(ex);
    }

    public boolean isPlainTextEditor() {
        return plainTextEditor;
    }

    public void setPlainTextEditor(boolean plainTextEditor) {
        ((ExpressionSheetPropertyComponent)getEditor()).setPlainTextEditor(plainTextEditor);
    }
}